#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

map<string, string> params;
const int maxEdgeCost = 1'000'000'000;

int get(string name, int def = 0) {
    if (params.count(name)) {
        return stoll(params[name]);
    } else {
        return def;
    }
}

vector<int> gen_costs() {
    int n = get("n");
    int copy = get("copies");
    int min = (get("mn") == 0 ? 1 : get("mn"));
    int max = (get("mx") == 0 ? maxEdgeCost : get("mx"));
    vector<int> edge;
    while (edge.size() < n - 1) {
        int value = rnd.next(min, max);
        for (int i = 0; i < copy && edge.size() < n - 1; i++) edge.push_back(value);
    }
    return edge;
}

void test_group1() {
    int n = get("n"), k = get("k"), modification = (get("modification") == 0 ? n : get("modification"));
    cout << n << " " << k << "\n";
    vector<int> values = gen_costs();
    vector<int> artifacts(n);
    for (int i = 0; i < modification; i++) artifacts[i] = rnd.next(5) % (k + 1);
    for (int i = 0; i < n; i++) {
        cout << artifacts[i];
        if (i != n - 1) cout << " ";
    }
    cout << "\n";
    for (int i = 1; i < n; i++) {
        // cout << i + 1 << " " << rnd.next(1, i) << " " << values[i - 1] << "\n";
        cout << i + 1 << " " << rnd.next(1, i) << "\n";
    }
}

void test_group2() {
    int n = get("n");
    int t = get("t");
    int k = get("k");
    cout << n << " " << k << "\n";

    vector<int> p(n);

    for (int i = 0; i < n; i++) {
        if (i > 0) p[i] = rnd.wnext(i, t);
    }

    vector<int> perm(n);
    iota(all(perm), 0);
    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int, int> > edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i], perm[p[i]]));
        else
            edges.push_back(make_pair(perm[p[i]], perm[i]));

    shuffle(edges.begin(), edges.end());
    vector<int> deg(n);
    for (auto [u, v] : edges) {
        deg[u]++;
        deg[v]++;
    }
    vector<int> pos, artifacts(n);
    for (int i = 0; i < n; i++) {
        if (deg[i] == 1) {
            pos.push_back(i);
        }
    }
    shuffle(all(pos));
    int cnt = 0;
    for (int i = 0; i < min((int)pos.size(), k); i++) {
        artifacts[pos[i]] = i + 1;
        cnt++;
    }
    while (cnt < k) {
        int j = rnd.next(187) % n;
        if (artifacts[j]) continue;
        artifacts[j] = cnt + 1;
        cnt++;
    }
    for (int i = 0; i < n; i++) {
        cout << artifacts[i];
        if (i != n - 1) cout << " ";
    }
    cout << "\n";
    vector<int> values = gen_costs();
    for (int i = 0; i + 1 < n; i++) {
        // cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << " " << values[i] << "\n";
        cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << "\n";
    }
}

void test_group3() {
    int n = get("n"), k = get("k");
    cout << n << " " << k << "\n";

    vector<int> perm(n);
    iota(all(perm), 0);

    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int, int> > edges;

    for (int i = 1; i < n; i++) {
        edges.push_back({perm[i], perm[0]});
    }

    shuffle(edges.begin(), edges.end());
    vector<int> pos(n), artifacts(n);
    iota(all(pos), 0);
    shuffle(all(pos));
    for (int i = 0; i < n; i++) {
        if (pos[i]) artifacts[pos[i]] = rnd.next(100) % (k + 1);
    }
    for (int i = 0; i < n; i++) {
        cout << artifacts[i];
        if (i != n - 1) cout << " ";
    }
    cout << "\n";
    vector<int> values = gen_costs();
    for (int i = 0; i + 1 < n; i++) {
        // cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << " " << values[i] << "\n";
        cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << "\n";
    }
}

void test_group4() {
    int n = get("n"), k = get("k"), modification = get("modification");
    cout << n << " " << k << "\n";

    vector<int> perm(n);
    iota(all(perm), 0);
    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int, int> > edges;

    for (int i = 1; i < n; i++) {
        edges.push_back({perm[i], perm[i - 1]});
    }
    shuffle(edges.begin(), edges.end());
    vector<int> pos(n), artifacts(n);
    iota(all(pos), 0);
    shuffle(all(pos));
    if (modification) {
        for (int i = 0; i < k; i++) {
            artifacts[pos[i]] = i + 1;
        }
    } else {
        for (int i = 0; i < n; i++) {
            artifacts[pos[i]] = rnd.next(100) % (k + 1);
        }
    }
    for (int i = 0; i < n; i++) {
        cout << artifacts[i];
        if (i != n - 1) cout << " ";
    }
    cout << "\n";
    vector<int> values = gen_costs();
    for (int i = 0; i + 1 < n; i++) {
        // cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << " " << values[i] << "\n";
        cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << "\n";
    }
}

void test_group5() {
    int n = get("n");
    int t = get("t");
    int k = get("k");
    cout << n << " " << k << "\n";

    vector<int> p(n);

    for (int i = 0; i < n; i++) {
        if (i > 0) p[i] = rnd.wnext(i, t);
    }

    vector<int> perm(n);
    iota(all(perm), 0);
    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int, int> > edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i], perm[p[i]]));
        else
            edges.push_back(make_pair(perm[p[i]], perm[i]));

    shuffle(edges.begin(), edges.end());
    vector<int> deg(n);
    for (auto [u, v] : edges) {
        deg[u]++;
        deg[v]++;
    }
    vector<int> pos, artifacts(n);
    for (int i = 0; i < n; i++) {
        if (deg[i] == 1) {
            pos.push_back(i);
        }
    }
    shuffle(all(pos));
    int cnt = 0;
    for (int i = 0; i < min((int)pos.size(), k); i++) {
        artifacts[pos[i]] = i + 1;
        cnt++;
    }
    while (cnt < min(n, 100 + rnd.next(10) % 14)) {
        int j = rnd.next(187) % n;
        if (artifacts[j]) continue;
        artifacts[j] = rnd.next(1531) % (k + 1);
        cnt++;
    }
    for (int i = 0; i < n; i++) {
        cout << artifacts[i];
        if (i != n - 1) cout << " ";
    }
    cout << "\n";
    vector<int> values = gen_costs();
    for (int i = 0; i + 1 < n; i++) {
        // cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << " " << values[i] << "\n";
        cout << edges[i].first + 1 << " " <<  edges[i].second + 1 << "\n";
    }
}

int32_t main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }

    int mode = get("mode");
    if (mode == 1) test_group1(); // full random
    if (mode == 2) test_group2(); // average with fixed height + only k arti
    if (mode == 3) test_group3(); // sun
    if (mode == 4) test_group4(); // bamboo
    if (mode == 5) test_group5(); // average with fixed height + more than k arti but in leaves 100%
    return 0;
}
