//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int& x : a) {
    cin >> x;
    --x;
  }
  vector<vector<pair<int, int>>> graph(n);
  for (int i = 0; i < n - 1; ++i) {
    int u, v, w;
    cin >> u >> v >> w;
    --u, --v;
    graph[u].emplace_back(v, w);
    graph[v].emplace_back(u, w);
  }
  ll const INF = ll(1e18);
  vector dist(1 << k, vector<ll>(n, INF));
  fill(dist[0].begin(), dist[0].end(), 0);
  for (int msk = 0; msk < (1 << k); ++msk) {
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<>> st;
    for (int v = 0; v < n; ++v) {
      st.emplace(dist[msk][v], v);
    }
    while (!st.empty()) {
      auto[d, v] = st.top(); st.pop();
      if (d != dist[msk][v]) {
        continue;
      }
      for (auto[u, w] : graph[v]) {
        if (d + w < dist[msk][u]) {
          dist[msk][u] = d + w;
          st.emplace(d + w, u);
        }
      }
    }
    for (int v = 0; v < n; ++v) {
      if (a[v] >= 0 && !(msk >> a[v] & 1)) {
        smin(dist[msk | (1 << a[v])][v], dist[msk][v]);
      }
    }
  }
  auto res = *min_element(dist.back().begin(), dist.back().end());
  cout << (res == INF ? -1 : res) << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
