#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

typedef long long ll;
typedef long double ld;

const ll SZ = 1e5 + 100, MSK = (1 << 7), INF = 1e9 * 1e9 + 100;

ll n, k;
vector<vector<pair<ll, ll>>> gr;
vector<ll> vec;

ll dp1[SZ][MSK], dp2[SZ][MSK], dp3[SZ][MSK]; // do not push up, push up, already pushed up
ll ans = INF;

void dfs(int v, int par = -1) {
    for (int i = 1; i < MSK; i++) dp1[v][i] = dp2[v][i] = dp3[v][i] = INF;

    if (vec[v] != 0) {
        dp1[v][(1ll << (vec[v] - 1))] = 0;
        dp2[v][(1ll << (vec[v] - 1))] = 0;
        dp3[v][(1ll << (vec[v] - 1))] = 0;
    }

    for (auto to : gr[v]) {
        if (to.first != par) {
            dfs(to.first, v);

            for (int i = 0; i < (1ll << k); i++) {
                for (int j = i; ; j = (j - 1) & i) {
                    dp1[v][i] = min(dp1[v][i], dp1[v][j] + dp1[to.first][(i ^ j)] + to.second * 2);

                    dp2[v][i] = min(dp2[v][i], dp1[v][j] + dp2[to.first][(i ^ j)] + to.second);
                    dp2[v][i] = min(dp2[v][i], dp2[v][j] + dp1[to.first][(i ^ j)] + to.second * 2);

                    dp3[v][i] = min(dp3[v][i], dp3[v][j] + dp1[to.first][(i ^ j)] + to.second * 2);
                    dp3[v][i] = min(dp3[v][i], dp1[v][j] + dp3[to.first][(i ^ j)] + to.second * 2);
                    dp3[v][i] = min(dp3[v][i], dp2[v][j] + dp2[to.first][(i ^ j)] + to.second);

                    if (j == 0) break;
                }
            }
        }
    }

    ans = min(ans, dp3[v][(1ll << k) - 1]);
}

signed main() {
    fastInp;

    cin >> n >> k;
    vec.resize(n);
    for (auto& c : vec) cin >> c;

    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        ll u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        gr[u].push_back({ v, c });
        gr[v].push_back({ u, c });
    }

    dfs(0);

    if (ans >= INF) {
        cout << "-1";
        return 0;
    }
    cout << ans;

    return 0;
}