#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m"), pl = opt<int>("pl"), pr = opt<int>("pr");
    bool ok = opt<bool>("ok");

    vector<int> p(n);
    vector<vector<int>> levels{{0}};
    int sum = 1;
    while (true) {
        int min_req = levels.back().size() * pl;
        if (sum + min_req > n) {
            int last_p = levels[levels.size() - 2].back();
            for (; sum < n; sum++) {
                levels.back().push_back(sum);
                p[sum] = last_p;
            }
            break;
        }
        int rest = levels.back().size();
        vector<int> level;
        for (int parent : levels.back()) {
            rest--;
            int count = rnd.next(pl, min(pr, n - sum - rest * pl));
            for (int i = 0; i < count; i++, sum++) {
                level.push_back(sum);
                p[sum] = parent;
            }
        }
        levels.push_back(level);
    }

    auto pm = rnd.perm(levels.back().size(), levels.back()[0]);
    for (int i = levels.back().size(); i < m; i++) {
        pm.push_back(rnd.next(levels.back()[0], levels.back().back()));
    }
    sort(pm.begin(), pm.end());

    vector<int> mapping(n);
    for (int l = 1; l < levels.size(); l++) {
        vector<vector<int>> groups(levels[l - 1].size());
        for (int i : levels[l]) {
            groups[p[i] - levels[l - 1][0]].push_back(i);
        }
        for (auto &group : groups) {
            auto pg = rnd.perm(group.size(), group[0]);
            for (int i = 0; i < group.size(); i++) {
                mapping[group[i]] = pg[i];
            }
        }
    }

    vector<int> resn(n), resm(m);
    for (int i = 1; i < n; i++) {
        resn[mapping[i]] = mapping[p[i]];
    }
    vector<pair<int, int>> order;
    for (int i = 0; i < m; i++) {
        int parent = mapping[pm[i]];
        order.emplace_back(parent, i);
        resm[i] = parent;
    }
    if (!ok) {
        int i = rnd.next(1, m - 1), j = i - 1;
        int iter = 0;
        while (resm[i] == resm[j] || resn[resm[i]] == resn[resm[j]]) {
            i = (i + 1) % m;
            j = (j + 1) % m;
            if (++iter > m) break;
        }
        if (iter > m) {
            j = rnd.next(0, m - 1);
        }
        int p1 = std::find(order.begin(), order.end(), make_pair(resm[i], i)) - order.begin();
        int p2 = std::find(order.begin(), order.end(), make_pair(resm[j], j)) - order.begin();
        swap(resm[i], resm[j]);
        swap(order[p1].first, order[p2].first);
    }

    sort(order.begin(), order.end());
    int cur = 0;
    while (cur < m) {
        int last = cur;
        while (last < m && order[last].first == order[cur].first) {
            last++;
        }
        shuffle(order.begin() + cur, order.begin() + last);
        cur = last;
    }
    vector<int> morder, mparent;
    for (auto &c : order) {
        morder.push_back(c.second + 1);
        mparent.push_back(c.first + 1);
    }
    for (int &i : resn) i++;
    sort(mparent.begin(), mparent.end());

    println(n, m);
    println(morder.begin(), morder.end());
    println(resn.begin() + 1, resn.end());
    println(mparent.begin(), mparent.end());

}