//  Copyright 2022 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;
  vector<int> a(m);
  for (int& x : a) {
    cin >> x;
    --x;
  }
  vector<int> p(n, -1);
  for (int i = 1; i < n; ++i) {
    cin >> p[i];
    --p[i];
  }
  vector<int> mn(n, m), mx(n, 0), s(n);
  for (int i = 0; i < m; ++i) {
    int x; cin >> x; --x;
    smin(mn[x], a[i]);
    smax(mx[x], a[i]);
    s[x] += 1;
  }
  for (int i = n - 1; i >= 0; --i) {
    if (s[i] != mx[i] - mn[i] + 1) {
      cout << "NO\n";
      return 0;
    }
    if (i > 0) {
      s[p[i]] += s[i];
      smax(mx[p[i]], mx[i]);
      smin(mn[p[i]], mn[i]);
    }
  }
  cout << "YES\n";

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
