#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};
 
const long double eps = 1e-6;
int n;
vector<point> mas;

inline long double readOperation(InStream& in) {
	point center;
	center.x = in.readDouble();
	center.y = in.readDouble();
	long double r = in.readDouble();
	if (r < 0)
		in.quitf(_wa, "Negative radius");
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		if (center.dist(mas[i]) < (r + eps) * (r + eps))
			cnt++;
	}
	if (2 * cnt < n) {
		in.quitf(_wa, "Not enough points %d", cnt);
	}
	return r;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    n = inf.readInt();
    mas.resize(n);
	for (int i = 0; i < n; i++) {
		mas[i].x = inf.readDouble();
		mas[i].y = inf.readDouble();
	}
	long double ja = readOperation(ans);
	long double pa = readOperation(ouf);
	if (pa < ja - eps) {
		quitf(_fail, "pans better than jans");
	}
	else if (pa > ja + eps) {
		quitf(_wa, "jans better than pans");
	} else {
		quitf(_ok, "good");
	}
}