#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};

const long double pi = acos(-1);

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    cout << setprecision(15) << fixed;

    int n = atoi(argv[1]);
    int q = atoi(argv[2]);
    int w = atoi(argv[3]);
    cout << n << endl;
    point center(0, 0);
    const double mx = 1e5;
    if (q) {
    	center.x = rnd.next(-mx, mx);
    	center.y = rnd.next(-mx, mx);
    }
    long double r = min(min(mx - center.x, center.x + mx), min(mx - center.y, center.y + mx));
    for (int i = 0; i < n; i++) {
    	long double phi = (rnd.next(0, (int)2e9) * pi) / 1e9;
    	long double rr = r;
    	if (w)
    		rr = rnd.next(0.0, rr);
    	cout << center.x + rr * cos(phi) << " " << center.y + rr * sin(phi) << "\n";
    }
}