#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};

const long double pi = acos(-1);

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    cout << setprecision(15) << fixed;

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int q = atoi(argv[3]);
    cout << n << endl;
    const double mx = 1e5;
    vector<point> centers(m);
    vector<point> mas(n);
    vector<long double> r(m);
    for (int i = 0; i < m; i++) {
    	centers[i].x = rnd.next(-mx, mx);
    	centers[i].y = rnd.next(-mx, mx);
    }
    long double d = centers[0].dist2(centers[1]);
    for (int i = 0; i < m; i++)
    	for (int j = i + 1; j < m; j++)
    		d = min(d, centers[i].dist2(centers[j]));
    for (int i = 0; i < m; i++)
    	d = min(d, min(min(mx - centers[i].x, centers[i].x + mx), min(mx - centers[i].y, centers[i].y + mx)));
    for (int i = 0; i < m; i++)
    	r[i] = rnd.next((double)d / 3, 2 * (double)d / 3);
    for (int i = 0; i < n; i++) {
    	int j = i % m;
    	if (q)
    		j = rnd.next(0, m - 1);
    	long double phi = rnd.next(0, (int)2e9) / 1e9 * pi;
    	long double w = rnd.next(0, (int)1e9) * r[j] / 1e9;
    	mas[i] = point(centers[j].x + w * cos(phi), centers[j].y + w * sin(phi));
    }
    shuffle(mas.begin(), mas.end());
    for (int i = 0; i < n; i++) {
    	cout << mas[i].x << " " << mas[i].y << endl;
    }
}