#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    cout << setprecision(15) << fixed;

    int n = atoi(argv[1]);
    cout << n << endl;
    vector<point> mas(n);
    const double mx = 1e5;
    mas[0].x = rnd.next(-mx, mx);
    mas[0].y = rnd.next(-mx, mx);
    mas[1].x = rnd.next(-mx, mx);
    mas[1].y = rnd.next(-mx, mx);
    for (int i = 2; i < n; i++) {
    	long double q = (long double)rnd.next(1, (int)1e9 - 1) / 1e9;
    	mas[i] = (mas[1] - mas[0]) * q + mas[0];
    }
    shuffle(mas.begin(), mas.end());
    for (int i = 0; i < n; i++) {
    	cout << mas[i].x << " " << mas[i].y << "\n";
    }
}