/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
struct point {
	long double x, y;
	point(long double x_ = 0, long double y_ = 0): x(x_), y(y_) {};
	point operator +(point p) {
		return point(x + p.x, y + p.y);
	}
	point operator -(point p) {
		return point(x - p.x, y - p.y);
	}
	point operator /(long double q) {
		return point(x / q, y / q);
	}
	point operator *(long double q) {
		return point(x * q, y * q);
	}
	void norm() {
		long double q = sqrt(x * x + y * y);
		x /= q;
		y /= q;
	}
	void perp() {
		swap(x, y);
		y *= -1;
	}
	long double dist(point p) {
		return (x - p.x) * (x - p.x) + (y - p.y) * (y - p.y);
	}
	long double dist2(point p) {
		return sqrt((x - p.x) * (x - p.x) + (y - p.y) * (y - p.y));
	}
};
 
struct line {
	long double a, b, c;
	line (long double a_ = 1, long double b_ = 1, long double c_ = 0): a(a_), b(b_), c(c_) {};
	line (point q, point w) {
		a = q.y - w.y;
		b = w.x - q.x;
		c = -q.x * a - q.y * b;
	}
	void perp(point q) {
		swap(a, b);
		a *= -1;
		c = -q.x * a - q.y * b;
	}
	long double dist(point q) {
		return (a * q.x + b * q.y + c) / sqrt(a * a + b * b);
	}
};

//x * q.a + y * q.b + q.c = 0;
//x * w.a + y * w.b + w.c = 0;
//x * (q.a * w.b - w.a * q.b) + q.c * w.b - w.c * q.b = 0
point inter(line q, line w) {
	return point(-(q.c * w.b - w.c * q.b) / (q.a * w.b - w.a * q.b), -(q.c * w.a - w.c * q.a) / (q.b * w.a - w.b * q.a));
}

const long double eps = 1e-8;

void solve() {
	int n;
	cin >> n;
	vector<point> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i].x >> mas[i].y;
	}
		
	auto check = [&](point center, long double d) {
		//cout << center.x << " " << center.y << " " << d << endl;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (center.dist2(mas[i]) < d + eps)
				cnt++;
			if (2 * cnt >= n)
				return true;
		}
		return false;
	};
	auto why = [&](point a, point b, point c) {
		line l1(a, b), l2(a, c);
		if (abs(l1.dist(c)) < eps)
			return point(-2e9, -2e9);
		l1.perp((a + b) / 2);
		l2.perp((a + c) / 2);
		return inter(l1, l2);
	};
	
	//cout << check(point(0, 0), 5) << endl;
	long double cur = 2e9;
	int curi = 0, curj = 1, curq = 2;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (mas[i].dist2(mas[j]) / 2 < cur && check((mas[i] + mas[j]) / 2, mas[i].dist2(mas[j]) / 2)) {
				cur = mas[i].dist2(mas[j]) / 2;
				curi = i;
				curj = j;
				curq = -1;
			}
			for (int q = j + 1; q < n; q++) {
				point cent = why(mas[i], mas[j], mas[q]);
				if (cent.dist2(mas[i]) < cur && check(cent, cent.dist2(mas[i]))) {
					cur = cent.dist2(mas[i]);
					curi = i;
					curj = j;
					curq = q;
				}				
			}
		}
	}
	//point che = why(mas[0], mas[2], mas[4]);
	//cout << che.x << " " << che.y << " " << che.dist2(mas[0]) << endl;
	int i = curi;
	int j = curj;
	int q = curq;
	if (curq == -1) {
		cout << ((mas[i] + mas[j]) / 2).x << " " << ((mas[i] + mas[j]) / 2).y << " " << mas[i].dist2(mas[j]) / 2 << endl;
	} else {
		point cent = why(mas[i], mas[j], mas[q]);
		cout << cent.x << " " << cent.y << " " << cent.dist2(mas[i]) << endl;
	}
}
 
 
int main() {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}