#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

const int ALPHA = 'z' - 'a' + 1;
const ll P = 43, M = 1e9 + 7;

vector<ll> power;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt_rand(seed);
auto randint = bind(uniform_int_distribution<int>(-1e9, 1e9), mt_rand);

struct node;
typedef node *nodeptr;

struct node {
    int x, y;
    nodeptr l = nullptr, r = nullptr;
    int size = 1;
    ll string_hash;

    nodeptr reset() {
        size = 1;
        l = r = nullptr;
        string_hash = power[x];
        return this;
    }

    node(int x) : x(x), y(randint()), string_hash(power[x]) {}
};

int _size(nodeptr root) {
    return root ? root->size : 0;
}

ll _string_hash(nodeptr root) {
    return root ? root->string_hash : 0;
}

nodeptr recalc(nodeptr root) {
    if (!root) return nullptr;
    root->size = 1 + _size(root->l) + _size(root->r);
    root->string_hash = (power[root->x] + _string_hash(root->l) + _string_hash(root->r)) % M;
    return root;
}

pair<nodeptr, nodeptr> split(nodeptr root, int value) {
    if (!root) return {nullptr, nullptr};
    if (root->x < value) {
        auto [l, r] = split(root->r, value);
        root->r = l;
        return {recalc(root), r};
    } else {
        auto [l, r] = split(root->l, value);
        root->l = r;
        return {l, recalc(root)};
    }
}

nodeptr merge(nodeptr l, nodeptr r) {
    if (!l) return r;
    if (!r) return l;
    if (l->y > r->y) {
        l->r = merge(l->r, r);
        return recalc(l);
    } else {
        r->l = merge(l, r->l);
        return recalc(r);
    }
}

nodeptr search(nodeptr root, int value) {
    if (!root) return nullptr;
    if (value < root->x) return search(root->l, value);
    else if (value > root->x) return search(root->r, value);
    return root;
}

void insert(nodeptr &root, nodeptr item) {
    auto [l, r] = split(root, item->x);
    root = merge(merge(l, item), r);
}

nodeptr extract(nodeptr &root, int value) {
    auto [l, tmp] = split(root, value);
    auto [item, r] = split(tmp, value + 1);
    root = merge(l, r);
    return item;
}

void transfer(nodeptr source, nodeptr &target) {
    if (!source) return;
    transfer(source->l, target);
    transfer(source->r, target);
    insert(target, source->reset());
}

nodeptr combine(nodeptr root1, nodeptr root2) {
    if (_size(root1) > _size(root2)) swap(root1, root2);
    transfer(root1, root2);
    return root2;
}

ll get_hash(nodeptr root, int from, int to) {
    auto [l, tmp] = split(root, from);
    auto [mid, r] = split(tmp, to);
    ll result = _string_hash(mid);
    merge(l, merge(mid, r));
    return result;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(string, p)
    int n = p.size();
    in(int, q)

    power.resize(n + 1);
    power[0] = 1;
    for (int i = 0; i < n; i++) {
        power[i + 1] = power[i] * P % M;
    }

    vector<nodeptr> pos(ALPHA);
    for (int i = 0; i < n; i++) {
        int c = p[i] - 'a';
        insert(pos[c], new node(i));
    }

    auto get_full_hash = [&](int from, int to) {
        ll result = 0;
        for (int c = 0; c < ALPHA; c++) result += get_hash(pos[c], from, to) * (c + 1);
        return result % M;
    };

    while (q--) {
        in(int, type)
        if (type == 1) {
            in(int, i)
            in(char, ch)
            i--;
            int c = ch - 'a';

            int cur = 0;
            for (; cur < ALPHA; cur++) {
                if (search(pos[cur], i)) break;
            }
            insert(pos[c], extract(pos[cur], i));
        } else if (type == 2) {
            in(char, ch1, ch2)
            int c1 = ch1 - 'a', c2 = ch2 - 'a';

            pos[c2] = combine(pos[c1], pos[c2]);
            pos[c1] = nullptr;
        } else {
            in(int, l1, r1, l2, r2);
            l1--, l2--;

            bool ok = r1 - l1 == r2 - l2;
            if (ok) {
                if (l1 > l2) {
                    swap(l1, l2), swap(r1, r2);
                }
                ll h1 = get_full_hash(l1, r1) * power[l2 - l1] % M;
                ll h2 = get_full_hash(l2, r2);
                ok = h1 == h2;
            }
            cout << (ok ? "YES" : "NO") << '\n';
        }
    }

}